<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" lang="en-US">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=11"/>
<meta name="generator" content="Doxygen 1.9.5"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>DayZExpansion: MiscGameplayFunctions Class Reference</title>
<link href="../../tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../jquery.js"></script>
<script type="text/javascript" src="../../dynsections.js"></script>
<link href="../../navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../resize.js"></script>
<script type="text/javascript" src="../../navtreedata.js"></script>
<script type="text/javascript" src="../../navtree.js"></script>
<link href="../../search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="../../search/searchdata.js"></script>
<script type="text/javascript" src="../../search/search.js"></script>
<link href="../../doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr id="projectrow">
  <td id="projectlogo"><img alt="Logo" src="../../doxygen_light.png"/></td>
  <td id="projectalign">
   <div id="projectname">DayZExpansion<span id="projectnumber">&#160;1.7.12</span>
   </div>
   <div id="projectbrief">DayZExpansion Script Documentation Courtecy of P4K1TZ</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.9.5 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
var searchBox = new SearchBox("searchBox", "../../search/",'.html');
/* @license-end */
</script>
<script type="text/javascript" src="../../menudata.js"></script>
<script type="text/javascript" src="../../menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(function() {
  initMenu('../../',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */
</script>
<div id="main-nav"></div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:d3d9a9a6595521f9666a5e94cc830dab83b65699&amp;dn=expat.txt MIT */
$(document).ready(function(){initNavTree('d2/d3e/a01851.html','../../'); initResizable(); });
/* @license-end */
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<div id="MSearchResults">
<div class="SRPage">
<div id="SRIndex">
<div id="SRResults"></div>
<div class="SRStatus" id="Loading">Loading...</div>
<div class="SRStatus" id="Searching">Searching...</div>
<div class="SRStatus" id="NoMatches">No Matches</div>
</div>
</div>
</div>
</div>

<div class="header">
  <div class="summary">
<a href="#pri-static-methods">Static Private Member Functions</a> &#124;
<a href="#pri-static-attribs">Static Private Attributes</a>  </div>
  <div class="headertitle"><div class="title">MiscGameplayFunctions Class Reference</div></div>
</div><!--header-->
<div class="contents">
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pri-static-methods" name="pri-static-methods"></a>
Static Private Member Functions</h2></td></tr>
<tr class="memitem:a28b1acc56d99dd373b16cef72e955e90"><td class="memItemLeft" align="right" valign="top">static override void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d3e/a01851.html#a28b1acc56d99dd373b16cef72e955e90">FilterObstructingObjects</a> (array&lt; Object &gt; potentiallyObstructingObjects, out array&lt; Object &gt; obstructingObjects)</td></tr>
<tr class="separator:a28b1acc56d99dd373b16cef72e955e90"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a87c7403ff57e259c11ea5a0eca62d52d"><td class="memItemLeft" align="right" valign="top">static override void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d3e/a01851.html#a87c7403ff57e259c11ea5a0eca62d52d">FilterObstructedObjectsByGrouping</a> (vector origin, float range, float distanceDelta, array&lt; Object &gt; objects, array&lt; Object &gt; obstructingObjects, out array&lt; Object &gt; filteredObjects, bool doDistanceCheck=false, bool checkIfDistanceCanBeIgnored=false, float maxDist=0)</td></tr>
<tr class="separator:a87c7403ff57e259c11ea5a0eca62d52d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a895dfc6847c3b191e57426b27c7b19f6"><td class="memItemLeft" align="right" valign="top">static override bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d3e/a01851.html#a895dfc6847c3b191e57426b27c7b19f6">IsObjectObstructed</a> (Object object, bool doDistanceCheck=false, vector distanceCheckPos=&quot;0 0 0&quot;, float maxDist=0)</td></tr>
<tr class="separator:a895dfc6847c3b191e57426b27c7b19f6"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a68a0e78efc8ff1d4b40ad349a9a976a3"><td class="memItemLeft" align="right" valign="top">static override bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d3e/a01851.html#a68a0e78efc8ff1d4b40ad349a9a976a3">IsObjectObstructedEx</a> (Object object, IsObjectObstructedCache cache, bool doDistanceCheck=false, vector distanceCheckPos=&quot;0 0 0&quot;, float maxDist=0)</td></tr>
<tr class="separator:a68a0e78efc8ff1d4b40ad349a9a976a3"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9bbbd596a524b53c4986565f320853c1"><td class="memItemLeft" align="right" valign="top">static override bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d3e/a01851.html#a9bbbd596a524b53c4986565f320853c1">IsObjectObstructedFilter</a> (Object object, IsObjectObstructedCache cache, <a class="el" href="../../d3/d19/a01847.html">PlayerBase</a> player)</td></tr>
<tr class="separator:a9bbbd596a524b53c4986565f320853c1"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a id="pri-static-attribs" name="pri-static-attribs"></a>
Static Private Attributes</h2></td></tr>
<tr class="memitem:acfe052cd9945c2cb51733cc05a145fd3"><td class="memItemLeft" align="right" valign="top">static bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="../../d2/d3e/a01851.html#acfe052cd9945c2cb51733cc05a145fd3">ObstructingObjectsContainExpansionBaseBuildingOrTent</a></td></tr>
<tr class="separator:acfe052cd9945c2cb51733cc05a145fd3"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p ><a class="el" href="../../dc/d8e/a00473.html">MiscGameplayFunctions.c</a></p>
<p >DayZ Expansion Mod www.dayzexpansion.com © 2022 DayZ Expansion Mod Team</p>
<p >This work is licensed under the Creative Commons Attribution-NonCommercial-NoDerivatives 4.0 International License. To view a copy of this license, visit <a href="http://creativecommons.org/licenses/by-nc-nd/4.0/">http://creativecommons.org/licenses/by-nc-nd/4.0/</a>. </p>

<p class="definition">Definition at line <a class="el" href="../../dc/d8e/a00473_source.html#l00013">13</a> of file <a class="el" href="../../dc/d8e/a00473_source.html">miscgameplayfunctions.c</a>.</p>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a id="a87c7403ff57e259c11ea5a0eca62d52d" name="a87c7403ff57e259c11ea5a0eca62d52d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a87c7403ff57e259c11ea5a0eca62d52d">&#9670;&#160;</a></span>FilterObstructedObjectsByGrouping()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static override void MiscGameplayFunctions::FilterObstructedObjectsByGrouping </td>
          <td>(</td>
          <td class="paramtype">vector&#160;</td>
          <td class="paramname"><em>origin</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>range</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>distanceDelta</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">array&lt; Object &gt;&#160;</td>
          <td class="paramname"><em>objects</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">array&lt; Object &gt;&#160;</td>
          <td class="paramname"><em>obstructingObjects</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">out array&lt; Object &gt;&#160;</td>
          <td class="paramname"><em>filteredObjects</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>doDistanceCheck</em> = <code>false</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>checkIfDistanceCanBeIgnored</em> = <code>false</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>maxDist</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p >Mostly vanilla Had to duplicate this so our versions of CanIgnoreDistanceCheck and IsObjectObstructedEx gets used and not the vanilla one</p>

<p class="definition">Definition at line <a class="el" href="../../dc/d8e/a00473_source.html#l00038">38</a> of file <a class="el" href="../../dc/d8e/a00473_source.html">miscgameplayfunctions.c</a>.</p>

</div>
</div>
<a id="a28b1acc56d99dd373b16cef72e955e90" name="a28b1acc56d99dd373b16cef72e955e90"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a28b1acc56d99dd373b16cef72e955e90">&#9670;&#160;</a></span>FilterObstructingObjects()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static override void MiscGameplayFunctions::FilterObstructingObjects </td>
          <td>(</td>
          <td class="paramtype">array&lt; Object &gt;&#160;</td>
          <td class="paramname"><em>potentiallyObstructingObjects</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">out array&lt; Object &gt;&#160;</td>
          <td class="paramname"><em>obstructingObjects</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p >Prevent accessing vicinity through Expansion basebuilding and vanilla tents</p>

<p class="definition">Definition at line <a class="el" href="../../dc/d8e/a00473_source.html#l00017">17</a> of file <a class="el" href="../../dc/d8e/a00473_source.html">miscgameplayfunctions.c</a>.</p>

</div>
</div>
<a id="a895dfc6847c3b191e57426b27c7b19f6" name="a895dfc6847c3b191e57426b27c7b19f6"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a895dfc6847c3b191e57426b27c7b19f6">&#9670;&#160;</a></span>IsObjectObstructed()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static override bool MiscGameplayFunctions::IsObjectObstructed </td>
          <td>(</td>
          <td class="paramtype">Object&#160;</td>
          <td class="paramname"><em>object</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>doDistanceCheck</em> = <code>false</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">vector&#160;</td>
          <td class="paramname"><em>distanceCheckPos</em> = <code>&quot;0&#160;0&#160;0&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>maxDist</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p >Vanilla Had to duplicate this so our version of IsObjectObstructedEx gets used and not the vanilla one</p>

<p class="definition">Definition at line <a class="el" href="../../dc/d8e/a00473_source.html#l00154">154</a> of file <a class="el" href="../../dc/d8e/a00473_source.html">miscgameplayfunctions.c</a>.</p>

</div>
</div>
<a id="a68a0e78efc8ff1d4b40ad349a9a976a3" name="a68a0e78efc8ff1d4b40ad349a9a976a3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a68a0e78efc8ff1d4b40ad349a9a976a3">&#9670;&#160;</a></span>IsObjectObstructedEx()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static override bool MiscGameplayFunctions::IsObjectObstructedEx </td>
          <td>(</td>
          <td class="paramtype">Object&#160;</td>
          <td class="paramname"><em>object</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">IsObjectObstructedCache&#160;</td>
          <td class="paramname"><em>cache</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>doDistanceCheck</em> = <code>false</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">vector&#160;</td>
          <td class="paramname"><em>distanceCheckPos</em> = <code>&quot;0&#160;0&#160;0&quot;</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">float&#160;</td>
          <td class="paramname"><em>maxDist</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p >Vanilla Had to duplicate this so our version of IsObjectObstructedFilter gets used and not the vanilla one</p>

<p class="definition">Definition at line <a class="el" href="../../dc/d8e/a00473_source.html#l00165">165</a> of file <a class="el" href="../../dc/d8e/a00473_source.html">miscgameplayfunctions.c</a>.</p>

</div>
</div>
<a id="a9bbbd596a524b53c4986565f320853c1" name="a9bbbd596a524b53c4986565f320853c1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a9bbbd596a524b53c4986565f320853c1">&#9670;&#160;</a></span>IsObjectObstructedFilter()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">static override bool MiscGameplayFunctions::IsObjectObstructedFilter </td>
          <td>(</td>
          <td class="paramtype">Object&#160;</td>
          <td class="paramname"><em>object</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">IsObjectObstructedCache&#160;</td>
          <td class="paramname"><em>cache</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="../../d3/d19/a01847.html">PlayerBase</a>&#160;</td>
          <td class="paramname"><em>player</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p >If target object is item or transport, do additional obstruction check to prevent accessing vicinity through Expansion basebuilding</p>
<p >If potentially obstructing object is not Expansion basebuilding, don't do additional check and return true (obstructed)</p>
<p >Potentially obstructing object is Expansion basebuilding</p>
<p >If not doing additional check, return true (obstructed)</p>
<p >Fix accessing vicinity through vanilla tents as well for good measure</p>
<p >We are only interested in large items</p>
<p >Check if the object itself was hit or something in front. As hitObject from RayCastBullet/SphereCastBullet is always NULL (no point in even passing the variable in, it will never get set), we have to do some jumping though hoops to determine what was actually hit.</p>
<p >Ignore vanilla territoryflag, tents and fireplaces as their collision box info isn't accurate</p>
<p >We have collision box info and going to assume it's accurate. Fire a short ray from hit position in the direction the object center would be if object was hit and check if it intersects with collision box to determine if we have hit the object (= not obstructed) or not (= hit something in front, obstructed).</p>
<p >ObjectCenterPos may not be actual object center (usually closer to the bottom), so a ray following that direction could come in at a steep angle if the player is very close and thus fail to intersect anything ("scraping the surface"). Get actual collision box center and use that instead. This will only point to object center if original hit was on object surface (this is intended).</p>
<p >Short offset to make sure the ray intersects if original hit was on object</p>
<p >Fall back to radius-based check. If distance from hit position to ObjectCenterPos is smaller than radius, we assume to have hit the object (= not obstructed), else we assume to have hit something in front (= obstructed)</p>

<p class="definition">Definition at line <a class="el" href="../../dc/d8e/a00473_source.html#l00187">187</a> of file <a class="el" href="../../dc/d8e/a00473_source.html">miscgameplayfunctions.c</a>.</p>

</div>
</div>
<h2 class="groupheader">Field Documentation</h2>
<a id="acfe052cd9945c2cb51733cc05a145fd3" name="acfe052cd9945c2cb51733cc05a145fd3"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acfe052cd9945c2cb51733cc05a145fd3">&#9670;&#160;</a></span>ObstructingObjectsContainExpansionBaseBuildingOrTent</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool MiscGameplayFunctions::ObstructingObjectsContainExpansionBaseBuildingOrTent</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p class="definition">Definition at line <a class="el" href="../../dc/d8e/a00473_source.html#l00015">15</a> of file <a class="el" href="../../dc/d8e/a00473_source.html">miscgameplayfunctions.c</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>DayzExpansion/BaseBuilding/Scripts/4_world/dayzexpansion_basebuilding/static/<a class="el" href="../../dc/d8e/a00473_source.html">miscgameplayfunctions.c</a></li>
</ul>
</div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="../../d2/d3e/a01851.html">MiscGameplayFunctions</a></li>
    <li class="footer">Generated by <a href="https://www.doxygen.org/index.html"><img class="footer" src="../../doxygen.svg" width="104" height="31" alt="doxygen"/></a> 1.9.5 </li>
  </ul>
</div>
</body>
</html>
